/*
    QAD - Qt ADvanced

    Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CHARDIALOG_H
#define CHARDIALOG_H

#include "qad_widgets_export.h"

#include <QDialog>


namespace Ui {
class CharDialog;
}


class QAD_WIDGETS_EXPORT CharDialog: public QDialog {
	Q_OBJECT

public:
	explicit CharDialog(QWidget * parent = nullptr);
	~CharDialog() override;

	QChar selectedChar() { return sel_char; }
	void setCharFont(const QFont & f);

private slots:
	void on_comboCategory_currentIndexChanged(int index);
	void on_verticalScroll_valueChanged(int index);
	void on_spinSize_valueChanged(int index);
	void on_tableChars_cellPressed(int row, int column);
	void on_tableChars_cellDoubleClicked(int, int) { on_buttonBox_accepted(); }
	void on_buttonBox_accepted();
	void on_buttonBox_rejected() { reject(); }

signals:
	void charSelected(QChar ch);

private:
	void changeEvent(QEvent * e) override;
	bool eventFilter(QObject * o, QEvent * e) override;
	void resizeEvent(QResizeEvent *) override;
	void clear();

	Ui::CharDialog * ui;
	QVector<QVector<QChar>> chars;
	QVector<QChar> * cur;
	QChar sel_char;
	int size, csize;
};

#endif // CHARDIALOG_H
